Leetcode hot100 在排序数组中查找元素的第一个和最后一个位置【中等】

首先,循环法实现二分查找的模版给我背过。精髓在于把退出循环的条件放在了while()里。

java 复制代码
    //二分查找法模版,背过!!!
    //因为我们拥有整个数组的全局视野,所以用循环就好了,不写递归了
    int findTarget(int[] nums, int target){
        int left = 0;
        int right=nums.length-1;
        
        //退出循环的条件放在while里
        while(left<=right){
            int mid=(left+right)/2;
            if(nums[mid]==target) return mid;
            else if(target>nums[mid]) left=mid+1;  //不用去做left是否溢出的判断,都在while()里做了
            else right=mid-1; //不用做right是否溢出的判断,都在while()里做了
        }
        
        return -1; //没有
    }

二分查找的变种,但只修改了if(numsmid==tartget)这个分支:标准的二分查找命中后,直接return,但是这里我们不return,继续找。

进行两次二分查找,第一次找最大下标,第二次找最小下标。

java 复制代码
class Solution {
    public int[] searchRange(int[] nums, int target) {
        //特殊情况
        if(nums.length==0)  return new int[]{-1,-1};
    

        int targetMaxIndex = findTargetMaxIndex(nums, target);
        int targetMinIndex;
        if(targetMaxIndex==-1){
            return new int[]{-1,-1};
        }else{
            targetMinIndex = findTargetMinIndex(nums,target);
        }

        return new int[] {targetMinIndex,targetMaxIndex};
    }

    private int findTargetMaxIndex(int[] nums,int target){
        //进入循环前的初始化
        int left=0;
        int right=nums.length-1;
        int maxIndex=-1;

        while(left<=right){
            int mid=(left+right)/2;
            //如果命中了,不return,假装没找到,继续往右边找更右边的
            if(nums[mid]==target) {
                maxIndex = Math.max(maxIndex, mid);
                left = mid + 1;

            //没命中,target在nums[mid]右边,继续往右边找(跟二分查找一样
            }else if(target>nums[mid]){
                left=mid+1;

             //没命中,target在nums[mid]左边,继续往左边找(跟二分查找一样
            }else{
                right=mid-1;
            }
        }

        if(maxIndex!=-1) return maxIndex;
        return -1;
    }

    private int findTargetMinIndex(int[] nums,int target){
        //进入循环前的初始化
        int left=0;
        int right=nums.length-1;
        int minIndex=nums.length;

        while(left<=right){
            int mid=(left+right)/2;
            //如果命中了,不return,假装没找到,继续往左边找更左边的
            if(nums[mid]==target){
                minIndex=Math.min(minIndex,mid);
                right=mid-1;

                //(跟二分查找一样
            }else if(target>nums[mid]){
                left=mid+1;

                //(跟二分查找一样
            }else{
                right=mid-1;
            }
        }

        if(minIndex!=nums.length) return minIndex;
        return -1;
    }
}
相关推荐
UIU1149 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场9 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi9 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
秋天的怀念_David10 小时前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院11 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng11 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
叉烧滑蛋13 小时前
B站台湾大学郭彦甫|MATLAB 学习笔记|04 变量与档案存取
数据结构
j7~14 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py15 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing15 小时前
LeetCode100 42.接雨水
java·算法·leetcode